<!-- As it must be compact, resizable and usable everywhere, an old good html tables seemed the best way to do this...-->
<table
  class="full-width"
  [attr.data-test-attachment-list-id]="attachmentListId"
>
  @for (attachment of attachments; track attachment) {
    <ng-container class="full-width">
      @switch (attachment.kind) {
        @case ('persisted-attachment') {
          <tr [attr.data-test-attachment-id]="attachment.id">
            <td class="name txt-ellipsis">
              <a
                nz-tooltip
                [sqtmCoreLabelTooltip]="attachment.name"
                [href]="getAttachmentDownloadURL(attachment)"
                (click)="openFilePreviewDialog($event, attachment)"
                >{{ attachment.name }}</a
              >
            </td>
            <td class="size">{{ attachment.size | convertFileSize }}</td>
            <td class="added-on txt-ellipsis">
              {{ 'sqtm-core.generic.date.prefix.added-on' | translate }}
              {{ attachment.addedOn | date: 'short' }}
            </td>
            @if (showDeleteButton) {
              <td class="delete">
                @if (canAttach && !attachment.pendingDelete) {
                  <span
                    [attr.data-test-element-id]="'delete-attachment'"
                    class="delete-attachment-icon"
                    (click)="delete(attachment)"
                  >
                    <i
                      nz-icon
                      nzType="sqtm-core-generic:delete"
                      nzTheme="outline"
                    ></i>
                  </span>
                }
              </td>
            }
          </tr>
          @if (attachment.pendingDelete) {
            <tr class="pending-delete">
              <td colspan="4">
                <div
                  class="full-width"
                  style="display: flex; justify-content: flex-end"
                >
                  <button
                    nz-button
                    nzType="primary"
                    [nzSize]="'small'"
                    class="sqtm-core-delete-button"
                    (click)="confirm(attachment)"
                  >
                    {{ 'sqtm-core.generic.label.delete' | translate }}
                  </button>
                  <button
                    class="m-l-10 m-r-20"
                    nz-button
                    nzType="default"
                    [nzSize]="'small'"
                    (click)="cancel(attachment)"
                  >
                    {{ 'sqtm-core.generic.label.cancel' | translate }}
                  </button>
                </div>
              </td>
            </tr>
          }
        }
        @case ('rejected-attachment') {
          <tr [attr.data-test-attachment-id]="attachment.id">
            <td class="name txt-ellipsis">
              <span style="color: red">{{ attachment.name }}</span>
            </td>
            <td class="size">
              <span>{{ attachment.size | convertFileSize }}</span>
            </td>
            <td class="added-on txt-ellipsis">
              <span>
                <i nz-icon nzType="warning" nzTheme="outline"></i>
              </span>
              <span class="m-l-10">{{
                'sqtm-core.generic.label.rejected' | translate
              }}</span>
            </td>
            <td class="delete" (click)="removeRejectedAttachment(attachment)">
              <span class="remove-rejected-warning-icon">
                <i nz-icon nzType="close" nzTheme="outline"></i>
              </span>
            </td>
          </tr>
          @for (error of attachment.errors; track error) {
            <tr class="flex-row">
              <td colspan="0">
                {{ error }}
              </td>
            </tr>
          }
        }
        @case ('uploading-attachment') {
          <tr class="row" [attr.data-test-attachment-id]="attachment.id">
            <td class="name">
              <span style="color: grey">{{ attachment.name }}</span>
            </td>
            <td colspan="3">
              <nz-progress
                class="full-width"
                [nzPercent]="attachment.uploadProgress"
              ></nz-progress>
            </td>
          </tr>
        }
      }
    </ng-container>
  }
</table>
